#!/bin/sh
WHEREAMI="`pwd`"
OLDPATH="$PATH"

if [ -z "$1" ]; then
  echo "[i] No wallet language specified. Defaulting to English."
  LANGUAGE="en"
else
  echo "[i] Language for wallet specified: $1"
  LANGUAGE="$1"
fi

# $HYBRIXD/deterministic/scripts/npm  => $HYBRIXD
SCRIPTDIR="`dirname \"$0\"`"
HYBRIXD="`cd \"$SCRIPTDIR/../../..\" && pwd`"
WEB_WALLET="`cd \"$SCRIPTDIR/../..\" && pwd`"
export PATH=$HYBRIXD/node/node_binaries/bin:"$PATH"

VIEW_BASEPATH="$WEB_WALLET/views"
HTML_FILEPATH="$WEB_WALLET/tmp/index.html"
SCSS_FILEPATH="$WEB_WALLET/tmp/index.scss"
JS_FILEPATH="$WEB_WALLET/tmp/index.js"
VERSION_FILEPATH="$WEB_WALLET/tmp/version.js"

echo "[.] Clear dist directory"
rm -rf "$WEB_WALLET/dist/"*
mkdir -p "$WEB_WALLET/dist/files"
mkdir -p "$WEB_WALLET/tmp"
echo "// automatically generated by scripts/npm/compile.sh" > "$JS_FILEPATH"
echo "const {hybrix} = require('../lib/hybrix.js');" >> "$JS_FILEPATH"
echo "hybrix.view.init({" >> "$JS_FILEPATH"

echo "// automatically generated by scripts/npm/compile.sh" > "$SCSS_FILEPATH"
echo "@import \"./scss/styles.scss\";" >> "$SCSS_FILEPATH"

FIRST="true"

cat "$WEB_WALLET/html/header.html" > "$HTML_FILEPATH"
while read VIEW_ID ; do
  if [ -z "${VIEW_ID}" ]; then
    continue
  fi
  echo "[.] Compiling ${VIEW_ID}..."

  VIEW_FILEPATH="$VIEW_BASEPATH/$VIEW_ID"
  # html
  if test -f  "$VIEW_FILEPATH/$VIEW_ID.html"; then
      echo "<div class=\"view\" id=\"view-$VIEW_ID\" style=\"display:none;\">" >> "$HTML_FILEPATH"
      cat "$VIEW_FILEPATH/$VIEW_ID.html" | node "$WEB_WALLET/scripts/npm/translate.js" "$VIEW_ID" "$LANGUAGE" >> "$HTML_FILEPATH"
      echo "</div>" >> "$HTML_FILEPATH"
  fi

  # js
  if test -f  "$VIEW_FILEPATH/$VIEW_ID.js"; then
    if [ "$FIRST" = "true" ]; then
      FIRST="false"
    else
      echo "," >> "$JS_FILEPATH"
    fi
    echo "  $VIEW_ID: require('$VIEW_FILEPATH/$VIEW_ID.js')\c" >> "$JS_FILEPATH"
  fi

  # scss
  if test -f  "$VIEW_FILEPATH/$VIEW_ID.scss"; then
      echo "@import \"../views/$VIEW_ID/$VIEW_ID.scss\";" >> "$SCSS_FILEPATH"
  fi

done < "$VIEW_BASEPATH/compileList"

echo "[.] Patching up files to prepare for compilation"
echo "\n});" >> "$JS_FILEPATH"
cat "$WEB_WALLET/html/footer.html" >> "$HTML_FILEPATH"
echo "// automatically generated by scripts/npm/compile.sh" > "$VERSION_FILEPATH"
echo "exports.version = {" >> "$VERSION_FILEPATH"
cat "$WEB_WALLET/package.json" | grep "version" >> "$VERSION_FILEPATH"
echo "a:0}.version;" >> "$VERSION_FILEPATH"
cp "$VIEW_BASEPATH/login/login-quotes-$LANGUAGE.json" "$WEB_WALLET/tmp/login-quotes.json"

echo "[.] Compiling Javascript assets using webpack"
if [ "$1" = "debug" ] || [ "$1" = "development" ]; then
  echo "[i] Webpack Development mode: don't uglify"
  "$WEB_WALLET/node_modules/webpack/bin/webpack.js" --mode development --config "$WEB_WALLET/webpack.config.js"
else
  echo "[i] Webpack Production mode: uglify"
  "$WEB_WALLET/node_modules/webpack/bin/webpack.js" --mode production --config "$WEB_WALLET/webpack.config.js"
fi

echo "[.] Compiling SCSS using node-sass"
"$WEB_WALLET/node_modules/node-sass/bin/node-sass" --output-style compressed "$SCSS_FILEPATH" > "$WEB_WALLET/dist/files/styles.css"

echo "[.] Minifying compiled HTML pages"
cat "$HTML_FILEPATH" | sed -e 's/^[[:blank:]]*//g' -e 's/[[:blank:]]*$//g' | sed -e ':a;N;$!ba;s/\n//g' > "$WEB_WALLET/dist/files/index.html"

echo "[.] Translating javascript strings to language: $LANGUAGE"
while read VIEW_ID ; do
  if [ -z "${VIEW_ID}" ]; then
    continue
  fi
  cat "$JS_FILEPATH" | node "$WEB_WALLET/scripts/npm/translate.js" "$VIEW_ID" "$LANGUAGE" > "$JS_FILEPATH.out"
  mv "$JS_FILEPATH.out" "$JS_FILEPATH"
done < "$VIEW_BASEPATH/compileList"
cp "$JS_FILEPATH" "$WEB_WALLET/dist/files/index.js"

echo "[.] Copying hybrix-lib and file assets"
cp "$WEB_WALLET/hybrix-lib/hybrix-lib.web.js" "$WEB_WALLET/dist/files/hybrix-lib.web.js"
cp -a "$WEB_WALLET/files/."  "$WEB_WALLET/dist/files"

echo "[.] Setting cache-renewal hashes for Javascript and CSS files"
INDEX_JS_HASH=$(node "$WEB_WALLET/scripts/npm/hash.js" "$WEB_WALLET/dist/files/index.js")
HYBRIXLIB_JS_HASH=$(node "$WEB_WALLET/scripts/npm/hash.js" "$WEB_WALLET/dist/files/hybrix-lib.web.js")
STYLES_CSS_HASH=$(node "$WEB_WALLET/scripts/npm/hash.js" "$WEB_WALLET/dist/files/styles.css")

mv "$WEB_WALLET/dist/files/index.js" "$WEB_WALLET/dist/files/index.$INDEX_JS_HASH.js"
mv "$WEB_WALLET/dist/files/hybrix-lib.web.js" "$WEB_WALLET/dist/files/hybrix-lib.web.$HYBRIXLIB_JS_HASH.js"
mv "$WEB_WALLET/dist/files/styles.css" "$WEB_WALLET/dist/files/styles.$STYLES_CSS_HASH.css"

sed -i -e "s/\$INDEX_JS_HASH/$INDEX_JS_HASH/" "$WEB_WALLET/dist/files/index.html"
sed -i -e "s/\$HYBRIXLIB_JS_HASH/$HYBRIXLIB_JS_HASH/" "$WEB_WALLET/dist/files/index.html"
sed -i -e "s/\$STYLES_CSS_HASH/$STYLES_CSS_HASH/" "$WEB_WALLET/dist/files/index.html"

# translate apps to most recent hybrixjslib
sed -i -e "s/\$HYBRIXLIB_JS_HASH/$HYBRIXLIB_JS_HASH/" "$WEB_WALLET/dist/files/app/cardpass/index.html"

echo "[.] Moving all library files to dist"
cp -a "$WEB_WALLET/module/."  "$WEB_WALLET/dist/"


export PATH="$OLDPATH"
cd "$WHEREAMI"
echo "[i] Compilation process done"
